<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Symbolic Information</TITLE>
<link href="suif1_6.html" rel=Next>
<link href="suif1_4.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_4.html">previous</A>, <A HREF="suif1_6.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC5" HREF="suif1_toc.html#TOC5">Symbolic Information</A></H2>

<P>
SUIF includes detailed symbolic information.  Symbols and types are
defined in nested scopes corresponding to the block structure of the
program.  A symbol table is attached to each element of the main SUIF
hierarchy that defines a new scope.  Symbols record information about
variables, labels, and procedures.  The SUIF type system is similar to C
but also has some support for Fortran and other languages.

</P>
<P>
The symbol tables (see section <A HREF="suif1_40.html#SEC40">Symbol Tables</A>) are defined in a tree
structure that forms a hierarchy parallel to the main SUIF hierarchy.
Each table records a pointer to its parent and keeps a list of its
children.  The global symbol table at the root is attached to the file
set and is shared across all the files.  Its children are the file
symbol tables attached to the file set entries.  The procedure symbol
tables for the AST procedure nodes are in the next level down, followed
by the block symbol tables for block nodes within the ASTs.  The block
symbol tables may be nested to any level.

</P>
<P>
Each symbol table contains a list of symbols (see section <A HREF="suif1_51.html#SEC51">Symbols</A>) that are
defined within the corresponding scope.  There are three different kinds
of symbols: variables, labels, and procedures.  Symbols are identified
by name or ID number.  The ID numbers are assigned automatically and
should always be unique within a particular scope.  Each symbol also has
a set of flags to record various attributes.

</P>
<P>
Variable symbols (see section <A HREF="suif1_55.html#SEC55">Variable Symbols</A>) may be declared in any
scope.  A variable symbol contains a pointer to the type for the
variable.  The type determines the amount of storage used to hold the
variable as well as the interpretation of its contents.  Some additional
flags are used for variable symbols.  These flags identify variables
that are formal parameters of the procedure and variables that have
their addresses taken.  Another flag is used to identify variables that
represent machine registers.  For variables that are not allocated on
the stack, a separate <STRONG>variable definition</STRONG> (see section <A HREF="suif1_58.html#SEC58">Variable Definitions</A>) must be entered in the symbol table.  A variable
definition records the alignment restriction for the variable's storage
and its initial contents.

</P>
<P>
Label symbols (see section <A HREF="suif1_54.html#SEC54">Label Symbols</A>) can only be declared within
procedures.  The position of a label in the code is marked with a
special instruction.

</P>
<P>
Procedure symbols (see section <A HREF="suif1_53.html#SEC53">Procedure Symbols</A>) can only be declared in
the global and file scopes.  A procedure symbol contains a pointer to
the AST for the body of the procedure if it exists.  It also provides
methods to read the body from an input file, write it to an output file,
and flush it from memory.  The procedure symbol also has a pointer to the
type for the procedure.

</P>
<P>
The SUIF type system (see section <A HREF="suif1_59.html#SEC59">Types</A>) is quite powerful.  It can
represent most, if not all, high-level types for C programs and for many
other languages.  The types are implemented with various kinds of type
nodes.  Each type node contains an operator that specifies the kind of
node.  Some of the type operators define base types that stand alone,
while other operators refer to other types nodes.  For example, a type
node with the <CODE>TYPE_INT</CODE> operator defines a new integer type.  A
node with the <CODE>TYPE_PTR</CODE> operator can then refer to the integer
type node to create a type for pointers to integers.  Operators are
available for integers, floating-point types, pointers, arrays,
functions, structures, unions, and enumerations.  Each type has a
particular size.  For some types, such as integers, the size can be set
directly, but for others it is determined automatically.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_4.html">previous</A>, <A HREF="suif1_6.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
